<template>
  <div class="home container">
    <FormComment
      ref="formCommentRef"
      @add-comment="addComment"
      @edit-comment="editComment"
    />
    <CommentList :comments="comments" 
      @delete-comment="deleteComment"
      @fill-form="fillForm"
    />
  </div>
</template>

<script>
import { CommentsService } from '../services/comments.service'

import CommentList from '@/components/CommentList'
import FormComment from '@/components/FormComment'

const commentsService = new CommentsService()

export default {
  name: 'Home',
  data() {
    return {
      comments: []
    }
  },
  async created() {
    this.comments = await commentsService.getAll()
  },
  methods: {
    async addComment(comment) {
      const createdComment = await commentsService.create(comment)
      this.comments.unshift(createdComment)
    },
    async editComment(comment) {
      const editedComment = await commentsService.edit(comment)
      const index = this.comments.findIndex(comment => comment.id === editedComment.id)
      if(index !== -1) {
        this.comments.splice(index, 1, editedComment)
      }
    },
    async deleteComment(id) {
      const response = await commentsService.delete(id)
      if(response.status == '200') {
        this.comments = this.comments.filter(comment => comment.id != id)
      } else {
        console.log('An error has occurred when deleting a comment')
      }
    },
    fillForm(comment) {
      this.$refs.formCommentRef.updateForm(comment)
      window.scrollTo({ 
        left: 0,
        top: 0,
        behavior: 'smooth'
      })
    }
  },
  components: {
    CommentList,
    FormComment
  }
}
</script>
<style scoped>
  .add-wrapper {
    display: flex;
    justify-content: center;
    align-items: center;
    margin: auto;
    width: 3rem;
    height: 3rem;
    border-radius: 50%;
    margin-bottom: 1rem;
    cursor: pointer;
  }

  .closed {
    background: green;
  }

  .closed:hover {
    background: #37af65;
  }

  .opened {
    background: darkred;
  }

  .opened:hover {
    background: red;
  }

  .fa-plus, .fa-minus {
    color: white;
  }

  .container {
    margin: auto;
    padding: 2rem;
    max-width: 1080px;
  }

</style>
